/*
 *  PHEX - The pure-java Gnutella-servent.
 *  Copyright (C) 2001 Gregor Koukkoullis - phex@kouk.de
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package phex.event;

import java.util.EventListener;

public interface DownloadCandidatesChangeListener
    extends EventListener
{
    /**
     * Called if a download file changed.
     */
    public void downloadCandidateChanged( int position );

    /**
     * Called if a download file was added.
     */
    public void downloadCandidateAdded( int position );

    /**
     * Called if a download file was removed.
     */
    public void downloadCandidateRemoved( int position );
}