/*
 *  PHEX - The pure-java Gnutella-servent.
 *  Copyright (C) 2001 Gregor Koukkoullis ( phex@kouk.de )
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package phex.gui.renderer;

import java.awt.*;
import javax.swing.*;
import javax.swing.table.DefaultTableCellRenderer;
import phex.ServiceManager;
import phex.utils.IPUtils;

public class IPCellRenderer extends DefaultTableCellRenderer
{
    private static Color darkYellow = new Color( 182, 182, 0 );

    public Component getTableCellRendererComponent(JTable table, Object value,
        boolean isSelected, boolean hasFocus, int row, int column)
    {
        super.getTableCellRendererComponent(table, value,
            isSelected, hasFocus, row, column);
        this.setForeground( Color.black );

        if ( value instanceof String )
        {
            String ip = (String) value;
            if ( IPUtils.isInvalidIP( ip ) )
            {
                this.setForeground( Color.red );
            }
            else if ( IPUtils.isPrivateIP( ip ) )
            {
                this.setForeground( darkYellow );
            }
        }
        return this;
    }
}