/*
 *  PHEX - The pure-java Gnutella-servent.
 *  Copyright (C) 2001 Gregor Koukkoullis ( phex@kouk.de )
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package phex.utils;

import java.io.File;

/**
 * The class filters out all files that are not directories.
 * This class extends javax.swing.filechooser.FileFilter and implements
 * java.io.FileFilter to be a multi use file filter for gui and io.
 */
public class DirectoryOnlyFileFilter extends javax.swing.filechooser.FileFilter
    implements java.io.FileFilter
{
    public boolean accept( File f )
    {
        return f.isDirectory();
    }

    public String getDescription()
    {
        return Localizer.getString( "DirectoryOnlyFileFilter" );
    }
}